<center><a href="ex11.c">Actual source code: ex11.c</a></center><br>

<html>
<head>
<title></title>
<meta name="generator" content="c2html 0.9.5">
<meta name="date" content="2007-03-29T00:33:28+00:00">
</head>

<body bgcolor="#FFFFFF">
<pre width="80">
<a name="line2">  2: </a>static char help[] = <font color="#666666">"Tests various 1-dimensional <A href="../../../../../docs/manualpages/DA/DA.html#DA">DA</A> routines.\n\n"</font>;

<a name="line4"> 4: </a> #include <A href="../../../../../include/petscda.h.html">petscda.h</A>
<a name="line5"> 5: </a> #include <A href="../../../../../include/petscsys.h.html">petscsys.h</A>

<a name="line9">  9: </a><strong><font color="#4169E1"><a name="main"></a>int main(int argc,char **argv)</font></strong>
<a name="line10"> 10: </a>{
<a name="line11"> 11: </a>  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       M = 5,N = 4,dof=1,s=1,wrap=0,i,n,j,k,m,cnt;
<a name="line13"> 13: </a>  <A href="../../../../../docs/manualpages/DA/DA.html#DA">DA</A>             da;
<a name="line14"> 14: </a>  <A href="../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A>    viewer;
<a name="line15"> 15: </a>  <A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>            local,locala,global,coors;
<a name="line16"> 16: </a>  <A href="../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>    *xy,*alocal;
<a name="line17"> 17: </a>  <A href="../../../../../docs/manualpages/Draw/PetscDraw.html#PetscDraw">PetscDraw</A>      draw;
<a name="line18"> 18: </a>  char           fname[16];

<a name="line20"> 20: </a>  <A href="../../../../../docs/manualpages/Sys/PetscInitialize.html#PetscInitialize">PetscInitialize</A>(&amp;argc,&amp;argv,(char*)0,help);

<a name="line22"> 22: </a>  <font color="#B22222">/* Create viewers */</font>
<a name="line23"> 23: </a>  <A href="../../../../../docs/manualpages/Viewer/PetscViewerDrawOpen.html#PetscViewerDrawOpen">PetscViewerDrawOpen</A>(<A href="../../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,0,<font color="#666666">""</font>,<A href="../../../../../docs/manualpages/Sys/PETSC_DECIDE.html#PETSC_DECIDE">PETSC_DECIDE</A>,<A href="../../../../../docs/manualpages/Sys/PETSC_DECIDE.html#PETSC_DECIDE">PETSC_DECIDE</A>,600,200,&amp;viewer);
<a name="line24"> 24: </a>  <A href="../../../../../docs/manualpages/Viewer/PetscViewerDrawGetDraw.html#PetscViewerDrawGetDraw">PetscViewerDrawGetDraw</A>(viewer,0,&amp;draw);
<a name="line25"> 25: </a>  <A href="../../../../../docs/manualpages/Draw/PetscDrawSetDoubleBuffer.html#PetscDrawSetDoubleBuffer">PetscDrawSetDoubleBuffer</A>(draw);

<a name="line27"> 27: </a>  <font color="#B22222">/* Read options */</font>
<a name="line28"> 28: </a>  <A href="../../../../../docs/manualpages/Sys/PetscOptionsGetInt.html#PetscOptionsGetInt">PetscOptionsGetInt</A>(<A href="../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,<font color="#666666">"-M"</font>,&amp;M,<A href="../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);
<a name="line29"> 29: </a>  <A href="../../../../../docs/manualpages/Sys/PetscOptionsGetInt.html#PetscOptionsGetInt">PetscOptionsGetInt</A>(<A href="../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,<font color="#666666">"-N"</font>,&amp;N,<A href="../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);
<a name="line30"> 30: </a>  <A href="../../../../../docs/manualpages/Sys/PetscOptionsGetInt.html#PetscOptionsGetInt">PetscOptionsGetInt</A>(<A href="../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,<font color="#666666">"-dof"</font>,&amp;dof,<A href="../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);
<a name="line31"> 31: </a>  <A href="../../../../../docs/manualpages/Sys/PetscOptionsGetInt.html#PetscOptionsGetInt">PetscOptionsGetInt</A>(<A href="../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,<font color="#666666">"-s"</font>,&amp;s,<A href="../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);
<a name="line32"> 32: </a>  <A href="../../../../../docs/manualpages/Sys/PetscOptionsGetInt.html#PetscOptionsGetInt">PetscOptionsGetInt</A>(<A href="../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,<font color="#666666">"-periodic"</font>,&amp;wrap,<A href="../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>);

<a name="line34"> 34: </a>  <font color="#B22222">/* Create distributed array and get vectors */</font>
<a name="line35"> 35: </a>  <A href="../../../../../docs/manualpages/DA/DACreate2d.html#DACreate2d">DACreate2d</A>(<A href="../../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,(<A href="../../../../../docs/manualpages/DA/DAPeriodicType.html#DAPeriodicType">DAPeriodicType</A>)wrap,DA_STENCIL_BOX,M,N,<A href="../../../../../docs/manualpages/Sys/PETSC_DECIDE.html#PETSC_DECIDE">PETSC_DECIDE</A>,
<a name="line36"> 36: </a>                    <A href="../../../../../docs/manualpages/Sys/PETSC_DECIDE.html#PETSC_DECIDE">PETSC_DECIDE</A>,dof,s,<A href="../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,<A href="../../../../../docs/manualpages/Sys/PETSC_NULL.html#PETSC_NULL">PETSC_NULL</A>,&amp;da);
<a name="line37"> 37: </a>  <A href="../../../../../docs/manualpages/DA/DASetUniformCoordinates.html#DASetUniformCoordinates">DASetUniformCoordinates</A>(da,0.0,1.0,0.0,1.0,0.0,0.0);
<a name="line38"> 38: </a>  <font color="#4169E1">for</font> (i=0; i&lt;dof; i++) {
<a name="line39"> 39: </a>    sprintf(fname,<font color="#666666">"Field %d"</font>,(int)i);
<a name="line40"> 40: </a>    <A href="../../../../../docs/manualpages/DA/DASetFieldName.html#DASetFieldName">DASetFieldName</A>(da,i,fname);
<a name="line41"> 41: </a>  }

<a name="line43"> 43: </a>  <A href="../../../../../docs/manualpages/DA/DAView.html#DAView">DAView</A>(da,viewer);
<a name="line44"> 44: </a>  <A href="../../../../../docs/manualpages/DA/DACreateGlobalVector.html#DACreateGlobalVector">DACreateGlobalVector</A>(da,&amp;global);
<a name="line45"> 45: </a>  <A href="../../../../../docs/manualpages/DA/DACreateLocalVector.html#DACreateLocalVector">DACreateLocalVector</A>(da,&amp;local);
<a name="line46"> 46: </a>  <A href="../../../../../docs/manualpages/DA/DACreateLocalVector.html#DACreateLocalVector">DACreateLocalVector</A>(da,&amp;locala);
<a name="line47"> 47: </a>  <A href="../../../../../docs/manualpages/DA/DAGetCoordinates.html#DAGetCoordinates">DAGetCoordinates</A>(da,&amp;coors);
<a name="line48"> 48: </a>  <A href="../../../../../docs/manualpages/Vec/VecGetArray.html#VecGetArray">VecGetArray</A>(coors,&amp;xy);

<a name="line50"> 50: </a><strong><font color="#4169E1"><A href="../../../../../docs/manualpages/Vec/VecView.html#VecView">VecView</A>(coors,<A href="../../../../../docs/manualpages/Viewer/PETSC_VIEWER_STDOUT_SELF.html#PETSC_VIEWER_STDOUT_SELF">PETSC_VIEWER_STDOUT_SELF</A>)</font></strong>;

<a name="line52"> 52: </a>  <font color="#B22222">/* Set values into local vectors */</font>
<a name="line53"> 53: </a>  <A href="../../../../../docs/manualpages/Vec/VecGetArray.html#VecGetArray">VecGetArray</A>(local,&amp;alocal);
<a name="line54"> 54: </a>  <A href="../../../../../docs/manualpages/DA/DAGetGhostCorners.html#DAGetGhostCorners">DAGetGhostCorners</A>(da,0,0,0,&amp;m,&amp;n,0);
<a name="line55"> 55: </a>  n    = n/dof;
<a name="line56"> 56: </a>  <font color="#4169E1">for</font> (k=0; k&lt;dof; k++) {
<a name="line57"> 57: </a>    cnt = 0;
<a name="line58"> 58: </a>    <font color="#4169E1">for</font> (j=0; j&lt;n; j++) {
<a name="line59"> 59: </a>      <font color="#4169E1">for</font> (i=0; i&lt;m; i++) {
<a name="line60"> 60: </a>        alocal[k+dof*cnt] = PetscSinScalar(2.0*PETSC_PI*(k+1)*xy[2*cnt]);
<a name="line61"> 61: </a>        cnt++;
<a name="line62"> 62: </a>      }
<a name="line63"> 63: </a>    }
<a name="line64"> 64: </a>  }
<a name="line65"> 65: </a>  <A href="../../../../../docs/manualpages/Vec/VecRestoreArray.html#VecRestoreArray">VecRestoreArray</A>(local,&amp;alocal);
<a name="line66"> 66: </a>  <A href="../../../../../docs/manualpages/Vec/VecRestoreArray.html#VecRestoreArray">VecRestoreArray</A>(coors,&amp;xy);

<a name="line68"> 68: </a>  <A href="../../../../../docs/manualpages/DA/DALocalToGlobal.html#DALocalToGlobal">DALocalToGlobal</A>(da,local,<A href="../../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>,global);

<a name="line70"> 70: </a>  <A href="../../../../../docs/manualpages/Vec/VecView.html#VecView">VecView</A>(global,viewer);

<a name="line72"> 72: </a>  <font color="#B22222">/* Send ghost points to local vectors */</font>
<a name="line73"> 73: </a>  <A href="../../../../../docs/manualpages/DA/DAGlobalToLocalBegin.html#DAGlobalToLocalBegin">DAGlobalToLocalBegin</A>(da,global,<A href="../../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>,locala);
<a name="line74"> 74: </a>  <A href="../../../../../docs/manualpages/DA/DAGlobalToLocalEnd.html#DAGlobalToLocalEnd">DAGlobalToLocalEnd</A>(da,global,<A href="../../../../../docs/manualpages/Sys/INSERT_VALUES.html#INSERT_VALUES">INSERT_VALUES</A>,locala);

<a name="line76"> 76: </a>  <font color="#B22222">/* Free memory */</font>
<a name="line77"> 77: </a>  <A href="../../../../../docs/manualpages/Viewer/PetscViewerDestroy.html#PetscViewerDestroy">PetscViewerDestroy</A>(viewer);
<a name="line78"> 78: </a>  <A href="../../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(global);
<a name="line79"> 79: </a>  <A href="../../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(local);
<a name="line80"> 80: </a>  <A href="../../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(locala);
<a name="line81"> 81: </a>  <A href="../../../../../docs/manualpages/DA/DADestroy.html#DADestroy">DADestroy</A>(da);
<a name="line82"> 82: </a>  <A href="../../../../../docs/manualpages/Sys/PetscFinalize.html#PetscFinalize">PetscFinalize</A>();
<a name="line83"> 83: </a>  <font color="#4169E1">return</font> 0;
<a name="line84"> 84: </a>}
<a name="line85"> 85: </a>









</pre>
</body>

</html>
